---
layout: layouts/exercise_python.njk
exercise: 3
points: 9
---
{% include 'blocks/teams_of_two.njk' %}

<ol>
  <li><strong>Equation solver</strong><br />
    Write a function <code>quadratic(a, b, c)</code> that solves quadratic
    equations. If you have trouble solving this task, have a look at the
    <a href="http://www.youtube.com/watch?v=TFcUGSBTA78">Python functions video
    tutorial on youtube</a>. In addition to what is shown in the video, the function
    must be able to deal with input leading to complex numbers as results.<br />
    Name the program file: <kbd>equations.py</kbd>
  </li>
  <li><strong>Sum</strong><br/>
    Write a function <code>sum_to(num)</code> that takes an integer
    <code>num &gt;= 0</code> as sole
    argument. The function should return the sum of all positive integers
    <code>&lt;= num</code>. In the function, assert that the input is
    &ge; 0 by using <code>assert</code>.<br/>
    Name the program file: <kbd>addition.py</kbd>
<li><strong>Conversion between Celsius and Fahrenheit</strong><br />
    Based on the formulas and your code of the second homework, write a function
    <code>celsius2fahrenheit(.)</code> that converts from Celsius to Fahrenheit
    and <code>fahrenheit2celsius(.)</code> for the other way around.<br />
    Name the program file: <kbd>conversion.py</kbd>
  </li>
  <li><strong>Geometry functions</strong><br />
    Implement the following functions calculating the perimeters, areas,
    surfaces or volumes of common gemoetric shapes:<br />
{% highlight "python" %}
perimeter_right_triangle(c1, c2)
area_right_triangle(c1, c2)
perimeter_circle(r)
area_circle(r)
surface_sphere(r)
volume_sphere(r)
surface_cylinder(r, h)
volume_cylinder(r, h)
surface_cone(r, h)
volume_cone(r, h)
{% endhighlight %}
    Name the program file: <kbd>geometry.py</kbd>
  </li>
  <li><strong>Business functions</strong><br />
    Implement a function that returns the
    terminal value of investing money:
    <code>terminal_value(capital, rate, years=1, tax=0)</code>. If a
    positive tax value is entered, every year's interest is to be reduced by
    the tax. The <code>rate</code> and <code>tax</code> parameters must be
    between 0 (0%) and 1 (100%). The number of years is integral.
    Use the formulas
    $$
      \mbox{capital} * (1 + \mbox{rate} * (1 - \mbox{tax}))^{\mbox{years}}
    $$
    <br />
    Implement a second function <code>interest(capital, rate, years=1, tax=0)</code>
    that returns the profit (compound interest) of investing money. <br />
    Name the program file: <kbd>business.py</kbd>
  </li>
  <li><strong>ROT13</strong><br/>
    Building on your solution to the ROT13 task in the last homework, write
    a function <code>encode(.)</code> that takes a string and returns the given
    string rotated by 13 places. For symmetry, also provide a corresponding
    <code>decode(.)</code> function. Convert the input to upper case before
    performing the rotation.<br />
    <ol><!--TODO: remove-->
      <li>Arire gehfg n cebtenz lbh qba'g unir fbheprf sbe.</li>
    </ol>
    Name the program file: <kbd>rot13.py</kbd>
  </li>
  <li><strong>VRPTW instances</strong><br/>
    Write a function <code>read_string_list(.)</code> that opens a VRPTW
    data file given as filename argument. The
    argument must be optional and default to "r101"). If the argument doesn't
    contain a filename extension (".txt"), this extension must be added before
    opening the file. Your function should return a list of strings - one for
    each entry. The headers should not be included in
    that list.<br/>
    A sample execution of this function:
{% highlight "python" %}
>>> read_string_list('r101.txt')
['  1    35.00    35.00     0.00     0.00   230.00     0.00\n',
 '  2    41.00    49.00    10.00   161.00   171.00    10.00\n',
...
 '100    20.00    26.00     9.00    83.00    93.00    10.00\n',
 '101    18.00    18.00    17.00   185.00   195.00    10.00\n']
{% endhighlight %}
    Name the program file: <kbd>vrptw_reader.py</kbd>
  </li>
  <li><strong>More on VRPTW instances</strong><br/>
    Expand the file of the last task to include more functions. The second
    function <code>get_demand(.)</code> takes two arguments. The first
    argument should
    be a list of strings (one for each entry) and the second should
    be a customer number (CUST_NO.). The function has to return that customer's
    demand as floating point number.
    The last function, <code>calc_distance(.)</code>, should take three
    parameters – a list of strings and two customer numbers.
    It should return the euclidean distance between the two customers.<br/>
    Name the program file: <kbd>vrptw_reader.py</kbd>
  </li>
  <li><strong>Main function</strong><br/>
    Write a single module that imports all the other modules you wrote for
    this homework. In the module implement a main function that uses all the
    functions you created. This main function is a first attempt of testing your code in the other modules. For each of the other tasks, create valid input data and deduce the functions output. Print these values, followed by the actual values the function produces for these inputs. Here's an example line this function could contain:
{% highlight "python" %}
def main():
    # ...
    print('prime_addition.prime_sum_to(9); expected: 17, actual:',
          prime_addition.prime_sum_to(9))
    # ...
{% endhighlight %}
    The main function must be called itself using the
    ifmain pattern. If all went well, the main function must return 0 to inform
    the calling process of the successful termination.
    Name the program file: <kbd>main.py</kbd>
  </li>
</ol>
